using Back.Common;
using Back.Services;
using FluentValidation;
using Shared.DTOs;

namespace Back.Validations
{
    // com ,invoice,model,action
    public class AUInvoiceItemValidation : AbstractValidator<Tuple<int,int, InvoiceItemDTO, eActionValidation>>
    {
        public AUInvoiceItemValidation(servInvoice servInvoice,ServCOD servCOD, servTaxPayer servTaxPayer, servInvoiceItem servInvoiceItem)
        {
            When(m => m.Item4 == eActionValidation.delete || m.Item4 == eActionValidation.add, () =>
            { 

            });
            When(m => m.Item4 == eActionValidation.update, () =>
            {
                RuleFor(r => r)
              .Custom((model, context) =>
              {
                  if (!model.Item3.ID.HasValue)
                      context.AddFailure("شناسه در حالت ویرایش نمی تواند خالی باشد");
                  if (!servInvoiceItem.Exist(model.Item1,model.Item2,model.Item3.ID.Value).Result)
                      context.AddFailure("شناسه یافت نشد");

              });

            });
            When(m => m.Item4 == eActionValidation.update || m.Item4 == eActionValidation.add, () =>
            {
                RuleFor(r => r)
                  .Custom((model, context) =>
                  {
                      if (model.Item3.CODID != null && model.Item3.CODID > 0)
                      {
                          if (!servCOD.ExistCodByCompanyID(model.Item3.CODID, model.Item1).Result)
                              context.AddFailure("کالا یافت نشد");
                      }

                      else context.AddFailure("کالا صحیح نمی باشد");

                  });
                RuleFor(r => r.Item3.am)
                .NotEmpty().WithMessage("تعداد مشخص نشده")
                .NotNull().WithMessage("تعداد مشخص نشده");

                RuleFor(r => r.Item3.fee)
                   .NotEmpty().WithMessage("مبلغ واحد مشخص نشده")
                   .NotNull().WithMessage("مبلغ واحد مشخص نشده");

                RuleFor(r => r).Custom(async (model, context) =>
                {
                    if (model.Item3.dis != null && model.Item3.dis > 0)
                        if (model.Item3.dis > model.Item3.am * model.Item3.fee)
                            context.AddFailure("مبلغ تخفیف نمی تواند از (تعداد * مبلغ واحد) بیشتر باشد");


                });
            });


            
            RuleFor(r => r)
             .Custom((model, context) =>
             {
                 if (model.Item2!=null && model.Item2 > 0)
                 {
                     var invoice = servInvoice.GetInvoiceByInvoiceID(model.Item1,model.Item2).Result;
                     if (invoice==null)
                         context.AddFailure("صورتحساب یافت نشد");
                     
                     
                     else
                     {
                         if ( servTaxPayer.ExistSuccessfulorSendorpendingInvoice(invoice).Result)
                             context.AddFailure("این صورتحساب به سازمان ارسال شده"+'\n'+
                        "برای تغییر ،صورتحساب را ابطال/اصلاح یا برگشت بزنید");
                         else if ((model.Item4 == eActionValidation.add || model.Item4 == eActionValidation.delete)
                     && invoice.invoiceType == InvoiceType.BackFrmSale)
                             context.AddFailure("آیتم های صورتحساب در وضعیت برگشت از فروش نمی تواند اضافه یا کم شود");
                         else if(invoice.invoiceType!=InvoiceType.Bidding 
                         && invoice.invoiceType != InvoiceType.Sale && invoice.invoiceType != InvoiceType.Repair)
                         {
                             context.AddFailure($"صورتحساب در حالت {invoice.invoiceType.GetEnumDisplayName()} نمی تواند ویرایش شود" +'\n'+
                                 $"فقط در حالت پیش نویس ، فاکتور و اصلاح (که به سازمان ارسال نشده باشد) میتوان سند را ویرایش کرد");
                         }
                     }
                 }

                 else context.AddFailure("صورتحساب صحیح نمی باشد");

             });

            
        }
    }
}
